/**
* 2005-2017 Magic Toolbox
*
* NOTICE OF LICENSE
*
* This file is licenced under the Software License Agreement.
* With the purchase or the installation of the software in your application
* you accept the licence agreement.
*
* You must not modify, adapt or create derivative works of this source code
*
*  @author    Magic Toolbox <support@magictoolbox.com>
*  @copyright Copyright (c) 2017 Magic Toolbox <support@magictoolbox.com>. All rights reserved
*  @license   https://www.magictoolbox.com/license/
*/


var magictoolboxImagesOrder;
updateMagicScrollIntervalID = null;

window['refreshProductImagesOriginal'] = window['refreshProductImages'];
window['refreshProductImages'] = function(id_product_attribute) {

    id_product_attribute = parseInt(id_product_attribute);

    //NOTE: to avoid double restart
    if (typeof(arguments.callee.last_id_product_attribute) !== 'undefined' && (arguments.callee.last_id_product_attribute == id_product_attribute)) {
        var r = window['refreshProductImagesOriginal'].apply(window, arguments);
        return r;
    }
    arguments.callee.last_id_product_attribute = id_product_attribute;

    //NOTE: does not scroll until tool is ready

    //NOTE: clears a timer
    if (updateMagicScrollIntervalID != null) {
        clearInterval(updateMagicScrollIntervalID);
        updateMagicScrollIntervalID = null;
    }
    //NOTE: set a timer
    mtIntervals = isProductMagicScrollReady ? 0 : 500;
    updateMagicScrollIntervalID = setInterval(function() {
        if (isProductMagicScrollReady) {
            clearInterval(updateMagicScrollIntervalID);
            updateMagicScrollIntervalID = null;

            var idCombination = $('#idCombination').val();
            for (var i in combinations) {
                if (combinations[i]['idCombination'] == idCombination) {
                    var position = jQuery.inArray(combinations[i]['image'], magictoolboxImagesOrder);
                    MagicScroll.jump('productMagicScroll', position);
                    //DEPRECATED:
                    //$('#bigpic').attr('src', $('#productMagicScroll img').get(position).src);
                    break;
                }
            }
        }
    }, mtIntervals);

    return window['refreshProductImagesOriginal'].apply(window, arguments);

}


